package com.yeejoin.amos.api.tool.controller;

import com.yeejoin.amos.api.tool.face.service.AgencyTreeService;
import com.yeejoin.amos.api.tool.face.service.DataBaseService;
import com.yeejoin.amos.api.tool.face.service.RelationService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.typroject.tyboot.core.foundation.enumeration.UserType;
import org.typroject.tyboot.core.restful.doc.TycloudOperation;
import org.typroject.tyboot.core.restful.utils.ResponseHelper;
import org.typroject.tyboot.core.restful.utils.ResponseModel;

import java.sql.Connection;

@CrossOrigin
@RestController
@Api(tags = "机构管理Api")
@RequestMapping(value = "/Agency")
public class RelationResource {
    @Autowired
    RelationService relationService;
    @Autowired
    DataBaseService dataBaseService;
    @Autowired
    AgencyTreeService agencyTreeService;

    @TycloudOperation(ApiLevel = UserType.AGENCY,needAuth = false)
    @DeleteMapping(value = "/relation/{agencyCodeId}/{sequenceNbrs}")
    @ApiOperation(httpMethod = "DELETE", value = "机构删除", notes = "机构删除")
    public ResponseModel<String> deleteDataBase(@PathVariable Long agencyCodeId, @PathVariable String sequenceNbrs) throws Exception {
        Long[] seqs = dataBaseService.stringToLong(sequenceNbrs);
        for (Long seq : seqs) {
            Connection connection = dataBaseService.connectNewDatabase(dataBaseService.queryBySeq(seq));
            relationService.deleteDataBase(connection,agencyTreeService.queryForAgencyCodeById(agencyCodeId),dataBaseService.queryBySeq(seq).getDbName());
        }
        return ResponseHelper.buildResponse("The data has been deleted !");
    }
}
