package com.yeejoin.amos.api.tool.face.service;

import com.yeejoin.amos.api.tool.face.orm.entity.ApiInfo;
import com.yeejoin.amos.api.tool.face.orm.dao.ApiInfoMapper;
import com.yeejoin.amos.api.tool.face.model.ApiInfoModel;
import org.apache.commons.beanutils.ConvertUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.typroject.tyboot.core.rdbms.service.BaseService;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import java.util.List;

@Service
public class ApiInfoService extends BaseService<ApiInfoModel,ApiInfo,ApiInfoMapper> {
    @Autowired
    ApiSourceService apiSourceService;

    /**
     * 分页查询
     */
    public Page<ApiInfoModel> queryForApiInfoPage(Page<ApiInfoModel> page,String apiSource ,String apiName)   {
        return this.queryForPage(page ,null ,false ,apiSource ,apiName);
    }

    /**
     * 列表查询 示例
     */
    public List<ApiInfoModel> queryForApiInfoList()   {
        return this.queryForList("" , false);
    }

    /**
     * 列表查询 示例
     */
    public List<ApiInfoModel> queryForApiInfoListByApiSource(String apiSource)   {
        return this.queryForList("" , false,apiSource);
    }

    /**
     * 删除多个模板
     */
    public Boolean[] deleteByIds(String sequenceNbr){
        String[] arr = sequenceNbr.split(",");
        Long[] seq = (Long[]) ConvertUtils.convert(arr, Long.class);
        Boolean[] arr2 = new Boolean[arr.length];
        for (int i = 0;i < arr.length;i++){
            arr2[i] = this.removeById(seq[i]);
        }
        return arr2;
    }
}
