package com.yeejoin.amos.api.tool.face.service;


import com.yeejoin.amos.api.tool.face.model.TemplateCateModel;
import com.yeejoin.amos.api.tool.face.model.TemplateCateTreeModel;
import com.yeejoin.amos.api.tool.face.model.VisualDesignerModel;
import com.yeejoin.amos.api.tool.face.orm.dao.VisualDesignerMapper;
import com.yeejoin.amos.api.tool.face.orm.entity.VisualDesigner;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.typroject.tyboot.core.rdbms.service.BaseService;

import java.util.ArrayList;
import java.util.List;


@Service
public class VisualDesignerService extends BaseService<VisualDesignerModel, VisualDesigner, VisualDesignerMapper> {

    @Autowired
    TemplateCateService templateCateService;
    @Autowired
    VisualDesignerService visualDesignerService;

    /**
     * 列表查询 示例
     */

    //    父List
    public List<VisualDesignerModel> queryForVisualDesignerList() {
        return this.queryForList("", false);
    }

    public List<TemplateCateTreeModel> getList() {
        List<TemplateCateTreeModel> treeList = new ArrayList<>();
        List<TemplateCateModel> templateCateModels = templateCateService.queryForTplCateList();
        List<VisualDesignerModel> visualDesignerModels = visualDesignerService.queryForVisualDesignerList();
        for(int i = 0; i < visualDesignerModels.size();i++){
            TemplateCateTreeModel templateCateTreeModel1 = new
                    TemplateCateTreeModel(visualDesignerModels.get(i).getSequenceNbr(), 0L,
                    visualDesignerModels.get(i).getDesignerName(),visualDesignerModels.get(i).getDesignerType());
            for (int j = 0, index = 0; j < templateCateModels.size(); j++){
                if(templateCateModels.get(j).getDesignerType().equals(templateCateTreeModel1.getDesignerType())){
                    TemplateCateTreeModel templateCateTreeModel2 = new
                            TemplateCateTreeModel(templateCateModels.get(j).getSequenceNbr(), templateCateTreeModel1.getSequenceNbr(),
                            templateCateModels.get(j).getCateName(), templateCateTreeModel1.getDesignerType(),null);
                    templateCateTreeModel1.getChildren().add(index++, templateCateTreeModel2);
                }
            }
            treeList.add(i, templateCateTreeModel1);
        }
        return treeList;
    }


}